<%@ Page Language="C#" enableViewState="false" %>
<%@ Import Namespace="System"%>
<%@ Import Namespace="System.Xml"%>
<%@ Import Namespace="System.Text"%>
<%@ Import Namespace="System.Net"%>
<%@ Import Namespace="System.Web.Services.Protocols"%>
<%@ Import Namespace="Microsoft.Crm.Platform.Proxy"%>
<HTML>
	<HEAD>
		<title>- c360 Solutions - Clone Entity ...</title>
		<link rel="stylesheet" type="text/css" href="/_common/styles/select.css">
		<link rel="stylesheet" type="text/css" href="/_nav/tabs.css">
		<link rel="stylesheet" type="text/css" href="/_nav/nav.css">
		<link rel="stylesheet" type="text/css" href="/_nav/menu.css">
		<link rel="stylesheet" type="text/css" href="/_common/styles/global.css">
		<link rel="stylesheet" type="text/css" href="/_forms/styles/form.css">
		<script language="javascript">
		function DisplayNewRecord(iType, sId) {
			try {
				// Refresh the main grid
				var objWindow = window.opener;
				while(objWindow.opener != undefined) {
					objWindow = objWindow.opener;
				}
				objWindow.crmGrid.location.reload();
			} catch (e) {  }
			
			try {
				// Display the newly created record
				window.opener.openObj(iType, sId);
			} catch (e) {  }
			
			try {
				// Close this window
				window.close();
			} catch (e) {  }
		}
		</script>
		<script language="C#" runat="server">
		
		CUserAuth objUserAuth;
		string _strServerName;
		string _strUrl;
		
	void Page_Init()
	{
			string strObjectId = Request.QueryString["oId"].ToString();
			string strObjectType = Request.QueryString["oType"].ToString();
			string strResult = "";
			
			_strServerName = ConfigurationSettings.AppSettings["CRMServer"].ToString();
			_strUrl = "http://" + _strServerName +  "/mscrmservices/" ;

			BizUser objCurrentUser = new BizUser();
			objCurrentUser.Credentials = CredentialCache.DefaultCredentials;
			objCurrentUser.Url = _strUrl + "BizUser.srf";
			objUserAuth = objCurrentUser.WhoAmI();

			strResult = RetrieveObject(Int16.Parse(strObjectType), strObjectId, objUserAuth);
		
			if (strResult != "") {
				strResult = CloneObject(Int16.Parse(strObjectType), strResult, objUserAuth);
			}

			if (strResult != "") {
				lblResult.Text += "<h4>Object sucessfully cloned.</h4><a href='javascript:DisplayNewRecord(" + strObjectType + @", """ + strResult + @""");'>Click here to close this window</br>and display the new object.</a></br></br></br>Another great CRM utility from</br><b>c360 Solutions - www.c360.com</b>";
			}
	}
	string RetrieveObject(int iObjectType, string strObjectId, CUserAuth objUserAuth) {
			string strResult = "";
		
			switch(iObjectType) {         
				case 1:         
					CRMAccount objAccount = new CRMAccount();
					objAccount.Credentials = CredentialCache.DefaultCredentials;
					objAccount.Url = _strUrl + "CRMAccount.srf";
					strResult = objAccount.Retrieve(objUserAuth, strObjectId, "");
					break;
			
				case 2:
					CRMContact objContact = new CRMContact();
					objContact.Url = _strUrl + "CRMContact.srf";
					strResult = objContact.Retrieve( objUserAuth, strObjectId, "");
					break;
				
				case 3:
					CRMOpportunity objOpportunity = new CRMOpportunity();
					objOpportunity.Url = _strUrl + "CRMOpportunity.srf";
					strResult = objOpportunity.Retrieve( objUserAuth, strObjectId, "");
					break;
				
				case 4:
					CRMLead objLead = new CRMLead();
					objLead.Url = _strUrl + "CRMLead.srf";
					strResult = objLead.Retrieve(  objUserAuth, strObjectId, "");
					break;

				case 112:
					CRMIncident objIncident = new CRMIncident();
					objIncident.Url = _strUrl + "CRMIncident.srf";
					strResult = objIncident.Retrieve(  objUserAuth, strObjectId, "");
					break;

				case 123:
					CRMCompetitor objCompetitor = new CRMCompetitor();
					objCompetitor.Url = _strUrl + "CRMCompetitor.srf";
					strResult = objCompetitor.Retrieve( objUserAuth, strObjectId, "");
					break;

				case 1084:
					CRMQuote objQuote = new CRMQuote();
					objQuote.Url = _strUrl + "CRMQuote.srf";
					strResult = objQuote.Retrieve( objUserAuth, strObjectId, "");
					break;

				case 1088:
					CRMSalesOrder objOrder = new CRMSalesOrder();
					objOrder.Url = _strUrl + "CRMSalesOrder.srf";
					strResult = objOrder.Retrieve( objUserAuth, strObjectId, "");
					break;

				case 1090:
					CRMInvoice objInvoice = new CRMInvoice();
					objInvoice.Url = _strUrl + "CRMInvoice.srf";
					strResult = objInvoice.Retrieve( objUserAuth, strObjectId, "");
					break;
			}

			return strResult;
		}


		string CloneObject(int iObjectType, string strObjectXml, CUserAuth objUserAuth) {
			StringBuilder strFieldSet = new StringBuilder("");
			string strResult = "";
		
			try {
				XmlDocument objXmlDoc = new XmlDocument();
				objXmlDoc.LoadXml(strObjectXml);
				XmlNode objNode = objXmlDoc.DocumentElement;
			
				int[] arrPositions = new int[] { 1, 2, 3, 4, 112, 123, 1084, 1088, 1090 };
				int iPosition = Array.BinarySearch( arrPositions, iObjectType);

				string[] arrDescriptionNode = new string[] { "name", "firstname", "name", "subject", "title", "name", "name", "name", "name" };
				string strDescriptionNode = arrDescriptionNode[iPosition];
			
				string[][] arrInvalidNodes = new string[][] {
							new string[] { "createdby", "createdon", "modifiedby", "modifiedon", "owningbusinessunit","statecode"},
							new string[] { "accountid", "address1_addressid", "address2_addressid","aging30","aging60","aging90"},
							new string[] { "contactid","fullname","yomifullname", "aging30","aging60","aging90","address1_addressid", "address2_addressid"  },
							new string[] { "opportunityid" },
							new string[] { "leadid", "yomifullname", "fullname","address1_addressid", "address2_addressid" },
							new string[] { "incidentid", "ticketnumber" },
							new string[] { "competitorid","organizationid", "address1_addressid", "address2_addressid"  },
							new string[] { "quoteid","quotenumber", "revisionnumber", "totallineitemamount", "totallineitemdiscountamount", "totaltax","totalamount","totalamountlessfreight","totaldiscountamount" },
							new string[] { "salesorderid","ordernumber","totallineitemamount", "totallineitemdiscountamount", "totaltax" ,"totalamount","totalamountlessfreight","totaldiscountamount" },
							new string[] { "invoiceid","invoicenumber", "totallineitemamount", "totallineitemdiscountamount", "totaltax","totalamount","totalamountlessfreight","totaldiscountamount"  }
						};
						
			// It is crucial to sort the arrays otherwise the binary search will not return the expected result.
			foreach (Array objArray in arrInvalidNodes) {
				Array.Sort(objArray);
			}
			
				strFieldSet.Append("<" + objNode.Name + ">");
				for (int i = 0; i < objNode.ChildNodes.Count; i++) {
					if (objNode.ChildNodes.Item(i).Name == strDescriptionNode) {
						strFieldSet.Append("<" + strDescriptionNode + ">Clone of " + System.Web.HttpUtility.HtmlEncode ( objNode.ChildNodes.Item(i).InnerText) + "</" + strDescriptionNode + ">");
					} else if ((Array.BinarySearch( arrInvalidNodes[0], objNode.ChildNodes.Item(i).Name) < 0) && (Array.BinarySearch( arrInvalidNodes[iPosition+1], objNode.ChildNodes.Item(i).Name) < 0)) {
						strFieldSet.Append(objNode.ChildNodes.Item(i).OuterXml);
					}
				}
				strFieldSet.Append("</" + objNode.Name + ">");

				switch(iObjectType) {
					case 1:
						CRMAccount objAccount = new CRMAccount();
						objAccount.Credentials = CredentialCache.DefaultCredentials;
						objAccount.Url = _strUrl + "CRMAccount.srf";
						strResult = objAccount.Create(objUserAuth, strFieldSet.ToString());
						break;
					
					case 2:
						CRMContact objContact = new CRMContact();
						objContact.Url = _strUrl + "CRMContact.srf";
						strResult = objContact.Create(  objUserAuth, strFieldSet.ToString());
						break;
					
					case 3:
						CRMOpportunity objOpportunity = new CRMOpportunity();
						objOpportunity.Url = _strUrl + "CRMOpportunity.srf";
						strResult = objOpportunity.Create(  objUserAuth, strFieldSet.ToString());
						break;

					case 4:
						CRMLead objLead = new CRMLead();
						objLead.Url = _strUrl + "CRMLead.srf";
						strResult = objLead.Create(objUserAuth, strFieldSet.ToString());
						break;

					case 112:
						CRMIncident objIncident = new CRMIncident();
						objIncident.Url = _strUrl + "CRMIncident.srf";
						strResult = objIncident.Create(  objUserAuth, strFieldSet.ToString());
						break;

					case 123:
						CRMCompetitor objCompetitor = new CRMCompetitor();
						objCompetitor.Url = _strUrl + "CRMCompetitor.srf";
						strResult = objCompetitor.Create(  objUserAuth, strFieldSet.ToString());
						break;

					case 1084:
						CRMQuote objQuote = new CRMQuote();
						objQuote.Url = _strUrl + "CRMQuote.srf";
						strResult = objQuote.Create(  objUserAuth, strFieldSet.ToString());
						break;

					case 1088:
						CRMSalesOrder objOrder = new CRMSalesOrder();
						objOrder.Url = _strUrl + "CRMSalesOrder.srf";
						strResult = objOrder.Create(  objUserAuth, strFieldSet.ToString());
						break;

					case 1090:
						CRMInvoice objInvoice = new CRMInvoice();
						objInvoice.Url = _strUrl + "CRMInvoice.srf";
						strResult = objInvoice.Create(  objUserAuth, strFieldSet.ToString());
						break;

				}
			} catch ( SoapException e ) {
				lblResult.Text += "Error creating new object:<br><br>";
				lblResult.Text += "Type: " + e.GetType() + "<br><br>";
				try {
					XmlDocument objErrorXml = new XmlDocument();
					objErrorXml.LoadXml("<error>" + e.Detail + "</error>");
					//lblResult.Text += "Description: " + objErrorXml.SelectSingleNode("//description").InnerText + "<br><br>";
					//lblResult.Text += "Details: " + objErrorXml.SelectSingleNode("//details").InnerText + "<br><br>";
					lblResult.Text += e.Detail.InnerText;
				} catch {
					lblResult.Text += "<xmp>" + e.Message + "</xmp>";
				}
			}
			return strResult;
		}

		</script>
	</HEAD>
	<body>
		<table class="layout" cellspacing="0" cellpadding="0" width="100%">
			<tr height="24">
				<td width="100%">
					<table cellspacing="0" cellpadding="0" class="mnubar">
						<tr>
							<td>
								<img src="/_imgs/mnu_vSpacer.gif" hspace="3"></td>
							<td class="icMenu" noWrap>
								<span tabIndex="0" class="menu">
									<table width="100%">
										<tr>
											<td align="right" class="mnuTitle mnuRight" noWrap><asp:label id="lblTitle" runat="server" EnableViewState="False" /></td>
										</tr>
									</table>
								</span>
							</td>
						</tr>
					</table>
					<div style="BORDER-TOP:#969693 1px solid; BORDER-BOTTOM:#c2c2bf 1px solid"></div>
				</td>
			</tr>
			<tr>
				<td class="leftBar" style="WIDTH:100%">
					<form runat="server" ID="Form1">
						<table width="100%">
							<tbody valign="top">
								<tr>
									<td align="center"><asp:Label id="lblResult" runat="server" EnableViewState="False" /></td>
								</tr>
							</tbody>
						</table>
					</form>
				</td>
			</tr>
			<tr height="23">
				<td class="statusBar">
					&nbsp;
				</td>
			</tr>
		</table>
	</body>
</HTML>
